Program MatchematicsGame;
		(* "Matchematics game" ("⥬᪠ ")  1.0*)
{४⨢}
	{$A+}{$B-}{$C FIXED DEMANDLOAD DISCARDABLE}
	{$D+}{$E-}{$F-}{$G+}{$I-}{$L-}
	{$M 40960,40961,655350}{$N-}{$Q-}{$R-}{$S-}{$T-}{$V-}{$X-}{$W+}
Uses Crt,Graph,Mouse;{$G Crt,Graph,Mouse}
Type FileText = Record
						 Docs:Array[1..21] Of String;
					 End;
	  Palett = Record
					  MonoBlack,
					  MonoBlue,
					  MonoGreen,
					  MonoCyan,
					  MonoRed,
					  MonoMagenta,
					  MonoBrown,
					  MonoLightGray,
					  MonoDarkGray,
					  MonoLightBlue,
					  MonoLightGreen,
					  MonoLightCyan,
					  MonoLightRed,
					  MonoLightMagenta,
					  MonoYellow,
					  MonoWhite : Integer;
				  End;
Label Start,StartPlace,IDigit,TheEnd,Restart;
Var Matrix:Array [1..9] Of Integer;
	Comp,Place,Digit,Number,Player1Num,Numb2,GrDriver,GrMode:Integer;
	COrP,FirstMove,RestartControl,L:Boolean;
	p:Pointer;
	HelpText:FileText;
	HlpFile:File Of FileText;
	Messages:Array[1..6,1..2] Of String;
	C:Char;
	Colors:Palett;
	Procedure StandartErrors(Errors,Scan:Integer);
		Begin
		NoSound;
		TextBackGround(Black);
			Writeln(#7);
			If Scan>0 Then
				Begin
					TextColor(White);
					ClrScr;
					Write(' Mouse not initializited...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(1);
				End;
			If Scan=0 Then
				Begin
					TextColor(White);
					ClrScr;
					Write(' Font not registered...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(2);
				End;
			CloseGraph;
			TextColor(White);
			If (Errors=-5) Or (Errors=-7) Or (Errors=-9) Then
				Begin
					ClrScr;
					Write(' Not enough memory...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(3);
				End;
			If (Errors<0) Then
				Begin
					ClrScr;
					Write(' Graphics not initializited...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(4)
				End;
			If Errors=5 Then
				Begin
					ClrScr;
					Write(' Init file error...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(5);
				End;
			If Errors=6 Then
				Begin
					ClrScr;
					Write(' Help file error...');
					TextColor(LightGray);
					Write('.');
					GotoXY(WhereX-1,WhereY);
					Writeln(' ');
					Halt(6);
				End;

		End;
	Procedure InitColors(NumOfPalette:Integer);
	Var InitFile:File Of Palett;
		Begin
			If NumOfPalette=0 Then
				Begin
					With Colors
						Do
							Begin
								MonoBlue:=1;
								MonoGreen:=2;
								MonoCyan:=3;
								MonoRed:=4;
								MonoMagenta:=5;
								MonoBrown:=6;
								MonoLightGray:=7;
								MonoDarkGray:=8;
								MonoLightBlue:=9;
								MonoLightGreen:=10;
								MonoLightCyan:=11;
								MonoLightRed:=12;
								MonoLightMagenta:=13;
								MonoYellow:=14;
								MonoWhite:=15;
								MonoBlack:=0;
							End;
					End
			Else
				Begin
					Assign(InitFile,'MathGame.Ini');
					If (IOResult<>0) Then StandartErrors(5,-1);
					Reset(InitFile);
					Seek(InitFile,NumOfPalette - 1);
					Read(InitFile,Colors);
					If (IOResult<>0) Then StandartErrors(5,-1);
					Close(InitFile);
				End;
		End;
	Procedure DrawMenus(Bar1,Bar2,Helvetica:String;Var BaseMean:Boolean);
			Label NextProc;
			Var MouseX,MouseY,TextX,TextX1,TextX2:Integer;
				L,R,ButtonControl:Boolean;
				C:Char;
		Procedure Button1(Bar1:String;Var BaseMean,ButtonControl:Boolean);
			Begin
						SetColor(Colors.MonoRed);
						MouseOff;
						OutTextXY(TextX1,222,Bar1);
						SetColor(Colors.MonoBlue);
						OutTextXY(TextX1,222,Bar1[1]);
						SetColor(Colors.MonoLightBlue);
						OutTextXY(TextX2,222,Bar2);
						SetColor(Colors.MonoLightRed);
						OutTextXY(TextX2,222,Bar2[1]);
						MouseOn;
						While (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238)
							Do
								Begin
									MouseInfo(MouseX,MouseY,L,R);
									If (KeyPressed) Then
										Begin
											C:=ReadKey;
											If (UpCase(C)=Bar1[1]) Then
												Begin
													BaseMean:=True;
													ButtonControl:=True;
													Exit;
												End;
											If (UpCase(C)=Bar2[1]) Then
												Begin
													BaseMean:=False;
													ButtonControl:=True;
													Exit;
												End;
										End;
										If (L=True) And (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238) Then
											Begin
												BaseMean:=True;
												ButtonControl:=True;
												Break;
											End;
								End;
			End;
		Procedure Button2(Bar2:String;Var BaseMean,ButtonControl:Boolean);
			Begin
				SetColor(Colors.MonoRed);
				MouseOff;
				OutTextXY(TextX2,222,Bar2);
				SetColor(Colors.MonoBlue);
				OutTextXY(TextX2,222,Bar2[1]);
				SetColor(Colors.MonoLightBlue);
				OutTextXY(TextX1,222,Bar1);
				SetColor(Colors.MonoLightRed);
				OutTextXY(TextX1,222,Bar1[1]);
				MouseOn;
					While (MouseX>=327) And (MouseX<=453) And (MouseY>=212) And (MouseY<=238)
						Do
							Begin
								MouseInfo(MouseX,MouseY,L,R);
									If (KeyPressed) Then
										Begin
											C:=ReadKey;
											If (UpCase(C)=Bar1[1]) Then
												Begin
													BaseMean:=True;
													ButtonControl:=True;
													Exit;
												End;
											If (UpCase(C)=Bar2[1]) Then
												Begin
													BaseMean:=False;
													ButtonControl:=True;
													Exit;
												End;
										End;
									If (L=True) And (MouseX>=327) And (MouseX<=453) And (MouseY>=212) And (MouseY<=238) Then
										Begin
											BaseMean:=False;
											ButtonControl:=True;
											Break;
										End;
							End;
			End;
		Procedure No_Button;
				Var MouseX,MouseY:Integer;
				L,R:Boolean;
			Begin
				MouseOff;
				SetColor(Colors.MonoLightBlue);
				OutTextXY(TextX1,222,Bar1);
				OutTextXY(TextX2,222,Bar2);
				SetColor(Colors.MonoLightRed);
				OutTextXY(TextX1,222,Bar1[1]);
				OutTextXY(TextX2,222,Bar2[1]);
				MouseOn;
				Repeat
				MouseInfo(MouseX,MouseY,L,R);
					If (KeyPressed) Then
						Begin
							C:=ReadKey;
							If (UpCase(C)=Bar1[1]) Then
								Begin
									BaseMean:=True;
									ButtonControl:=True;
									Exit;
								End;
							If (UpCase(C)=Bar2[1]) Then
								Begin
									BaseMean:=False;
									ButtonControl:=True;
									Exit;
								End;
						End;
				Until (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238)
						Or
						(MouseX>=327) And (MouseX<=453) And (MouseY>=212) And (MouseY<=238);
			End;
		Begin
			MouseOff;
			SetTextStyle(DefaultFont,0,0);
			SetColor(Colors.MonoGreen);
			SetFillStyle(10,Colors.MonoGreen);
			Bar3D(175,170,465,250,0,TopOn);
			SetColor(Colors.MonoGreen);
			SetFillStyle(11,Colors.MonoLightRed);
			Bar3D(185,210,315,240,3,TopOn);
			Bar3D(325,210,455,240,3,TopOn);
			SetColor(Colors.MonoLightBlue);
			TextX1:=185 + Round(65 - (Length(Bar1)*8)/2);
			OutTextXY(TextX1,222,Bar1);
			TextX2:=325 + Round(65 - (Length(Bar2)*8)/2);
			OutTextXY(TextX2,222,Bar2);
			TextX:=175 + Round(145 - (Length(Helvetica)*8)/2);
			SetColor(Colors.MonoYellow);
			OutTextXY(TextX,187,Helvetica);
			MouseOn;
			L:=False;
			{SetMousePos(240,225);}
			Repeat
			MouseInfo(MouseX,MouseY,L,R);
				ButtonControl:=False;
					If (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238) Then Button1(Bar1,BaseMean,ButtonControl)
						Else
					If (MouseX>=327) And (MouseX<=453) And (MouseY>=212) And (MouseY<=238) Then Button2(Bar2,BaseMean,ButtonControl)
						Else No_Button;
					If ButtonControl=True Then Goto NextProc;
					If (KeyPressed) Then
						Begin
							C:=ReadKey;
							If (UpCase(C)=Bar1[1]) Then
								Begin
									BaseMean:=True;
									Goto NextProc;
								End;
							If (UpCase(C)=Bar2[1]) Then
								Begin
									BaseMean:=False;
									Goto NextProc;
								End;
						End;
			Until ((L=True) And (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238))
					Or
					((L=True) And (MouseX>=327) And (MouseX<=453) And (MouseY>=212) And (MouseY<=238));
		NextProc :
		Sound(900);
		Delay(700);
		NoSound;
		End;
	Procedure ExitGame;
		Begin
			CloseGraph;
			MouseOff;
			NoSound;
			ClrSCr;
			TextColor(Green + Blink);
			WriteLn(' 室  ! Come again !');
			GotoXY(46,25);
			TextColor(Red + Blink);
			Write('Artiom Nechiporuck');
			TextColor(LightGray + Blink);
			Write(' produced( )2003');
			GotoXY(74,25);
			TextColor(LightGray);
			Write('c');
			GotoXY(1,2);
			C:=ReadKey;
			ClrSCr;
			TextColor(Green);
			WriteLn(' 室  ! Come again !');
			GotoXY(46,25);
			TextColor(Red);
			Write('Artiom Nechiporuck');
			TextColor(LightGray);
			Write(' produced(c)2003');
			GotoXY(1,2);
			Halt(1);
		End;
	Procedure Stop;
		Var ExitCtrl:Boolean;
		Begin
			ExitCtrl:=False;
			MouseOff;
			GetImage(170,165,470,255,p^);
			MouseOn;
			DrawMenus('Yes','No','Are you sure ?',ExitCtrl);
			If (ExitCtrl=True) Then ExitGame;
			MouseOff;
			PutImage(170,165,p^,NormalPut);
			MouseOn;
		End;
	Procedure Help;
		Var C:Char;
			 TextX:Integer;
		Begin
			SetColor(LightBlue);
			SetFillStyle(1,White);
			MouseOff;
			Bar3D(470,140,625,450,0,TopOn);
			SetColor(LightMagenta);
			SetFillStyle(1,DarkGray);
			Bar(526,136,568,144);
			OutTextXY(530,136,'Help');
			SetColor(Black);
			For TextX:=2 To 21
				Do
					Begin
						If (HelpText.Docs[TextX][1]='#') Then Break;
						OutTextXY(475,116 + TextX*16,HelpText.Docs[TextX]);
					End;
			MouseOn;
			C:=ReadKey;
			SetFillStyle(0,0);
			MouseOff;
			Bar3D(470,130,625,450,0,TopOn);
			MouseOn;
		End;
	 Procedure SelectColors;
		 Var MouseX,MouseY,I,Step:Integer;
			  L,R,AcceptControl:Boolean;
			  C:Char;
			Procedure PutCircle(SwitchPosition:Integer);
				Begin
					SetFillStyle(1,Colors.MonoRed);
					SetColor(Colors.MonoRed);
						If SwitchPosition=1 Then
							Begin
								Circle(230,43,2);
								FloodFill(231,44,Colors.MonoRed);
								SetFillStyle(0,0);
								FloodFill(231,61,Colors.MonoLightBlue);
								FloodFill(231,78,Colors.MonoLightBlue);
								FloodFill(231,95,Colors.MonoLightBlue);
								FloodFill(231,112,Colors.MonoLightBlue);
							End;
						If SwitchPosition=2 Then
							Begin
								Circle(230,60,2);
								FloodFill(231,61,Colors.MonoRed);
								SetFillStyle(0,0);
								FloodFill(231,44,Colors.MonoLightBlue);
								FloodFill(231,78,Colors.MonoLightBlue);
								FloodFill(231,95,Colors.MonoLightBlue);
								FloodFill(231,112,Colors.MonoLightBlue);
							End;
						If SwitchPosition=3 Then
							Begin
								Circle(230,77,2);
								FloodFill(231,78,Colors.MonoRed);
								SetFillStyle(0,0);
								FloodFill(231,44,Colors.MonoLightBlue);
								FloodFill(231,61,Colors.MonoLightBlue);
								FloodFill(231,95,Colors.MonoLightBlue);
								FloodFill(231,112,Colors.MonoLightBlue);
							End;
						If SwitchPosition=4 Then
							Begin
								Circle(230,94,2);
								FloodFill(231,95,Colors.MonoRed);
								SetFillStyle(0,0);
								FloodFill(231,44,Colors.MonoLightBlue);
								FloodFill(231,61,Colors.MonoLightBlue);
								FloodFill(231,78,Colors.MonoLightBlue);
								FloodFill(231,112,Colors.MonoLightBlue);
							End;
						If SwitchPosition=5 Then
							Begin
								Circle(230,111,2);
								FloodFill(231,112,Colors.MonoRed);
								SetFillStyle(0,0);
								FloodFill(231,44,Colors.MonoLightBlue);
								FloodFill(231,61,Colors.MonoLightBlue);
								FloodFill(231,78,Colors.MonoLightBlue);
								FloodFill(231,95,Colors.MonoLightBlue);
							End;
				End;
{			Procedure Accept{(AcceptControl:Boolean);
				Var MouseX,MouseY:Integer;
					 L,R:Boolean;
				Begin
					MouseOff;
					Ac:=False;
					SetColor(Colors.MonoRed);
					OutTextXY(179,133,'ccept');
					SetColor(Colors.MonoBlue);
					OutTextXY(171,133,'A');
					MouseOn;
					While (MouseX>=168) And (MouseX<=222) And (MouseY>=128) And (MouseY<=142)
						Do
							Begin
								MouseInfo(MouseX,MouseY,L,R);
								If (MouseX<168) Or (MouseX>222) Or (MouseY<128) Or (MouseY>142) Then Break;
								If (L=True) And (MouseX>=168) And (MouseX<=222) And (MouseY>=128) And (MouseY<=142) Then
									Begin
										Ac:=True;
										Break;
									End;
								If ((L=True) And (MouseX>=566) And (MouseX<=613) And (MouseY>=6) And (MouseY<=19)) Then Help;
								If (L=True) And (MouseX>=26) And (MouseX<=75) And (MouseY>=3) And (MouseY<=22) Then Stop;
								If (KeyPressed) Then
									Begin
										C:=ReadKey;
										If (UpCase(C)='A') Then
											Begin
												Ac:=True;
												Exit;
											End;
									End;
							End;
					MouseOff;
					SetColor(Colors.MonoLightBlue);
					OutTextXY(179,133,'ccept');
					SetColor(Colors.MonoLightRed);
					OutTextXY(171,133,'A');
					MouseOn;
				End;}
		Procedure Accept(Var AcceptControl:Boolean);
			Begin
						AcceptControl:=False;
						SetColor(Colors.MonoRed);
						OutTextXY(171,133,'Accept');
						SetColor(Colors.MonoBlue);
						OutTextXY(171,133,'A');
						MouseOn;
			While (MouseX>=168) And (MouseX<=222) And (MouseY>=128) And (MouseY<=142)
							Do
								Begin
									MouseInfo(MouseX,MouseY,L,R);
									If (KeyPressed) Then
										Begin
											C:=ReadKey;
											If (UpCase(C)='A') Then
												Begin
													AcceptControl:=True;
													Exit;
												End;
										End;
										If (L=True) And (MouseX>=187) And (MouseX<=313) And (MouseY>=212) And (MouseY<=238) Then
											Begin
												AcceptControl:=True;
												Break;
											End;
								End;
			End;

		Begin
			MouseOff;
			SetColor(Colors.MonoLightBlue);
			OutTextXY(171,133,'Accept');
			SetColor(Colors.MonoLightRed);
			OutTextXY(171,133,'A');
			SetColor(Colors.MonoLightGreen);
			SetFillStyle(0,0);
			Bar(145,41,209,49);
			Bar(145,57,177,65);
			Bar(145,73,169,81);
			Bar(145,89,217,97);
			Bar(145,105,193,113);
			OutTextXY(145,41,'Standart');
			OutTextXY(145,57,'Blue');
			OutTextXY(145,73,'Hot');
			OutTextXY(145,89,'Dark ping');
			OutTextXY(145,105,'Marine');
			SetColor(Colors.MonoLightBlue);
			Step:=26;
			For I:=1 To 5
				Do
					Begin
						Step:=Step + 17;
						Circle(230,Step,5);
						FloodFill(231,Step + 1,Colors.MonoLightBlue);
					End;
			I:=0;
			MouseOn;
			Repeat
				MouseInfo(MouseX,MouseY,L,R);
				If (KeyPressed) Then
					Begin
						C:=ReadKey;
							If (UpCase(C)='A') Then
								Begin
									AcceptControl:=True;
									Break;
								End;
					End;
				If (MouseX>=168) And (MouseX<=222) And (MouseY>=128) And (MouseY<=142) Then Accept(AcceptControl);
				If (AcceptControl) Then Break;
				SetColor(Colors.MonoRed);
				OutTextXY(171,133,'Accept');
				SetColor(Colors.MonoBlue);
				OutTextXY(171,133,'A');
				If ((L=True) And (MouseX>=566) And (MouseX<=613) And (MouseY>=6) And (MouseY<=19)) Then Help;
				If (L=True) And (MouseX>=26) And (MouseX<=75) And (MouseY>=3) And (MouseY<=22) Then Stop;
				If (L=True) And (MouseX>=227) And (MouseX<=235) And (MouseY>=39) And (MouseY<=47) And (I<>0) Then
					Begin
						MouseOff;
						PutCircle(1);
						I:=0;
						MouseOn;
					End;
				If (L=True) And (MouseX>=227) And (MouseX<=235) And (MouseY>=57) And (MouseY<=65) And (I<>1) Then
					Begin
						MouseOff;
						PutCircle(2);
						I:=1;
						MouseOn;
					End;
				If (L=True) And (MouseX>=227) And (MouseX<=235) And (MouseY>=73) And (MouseY<=81) And (I<>2) Then
					Begin
						MouseOff;
						PutCircle(3);
						I:=2;
						MouseOn;
					End;
				If (L=True) And (MouseX>=227) And (MouseX<=235) And (MouseY>=90) And (MouseY<=98) And (I<>3) Then
					Begin
						MouseOff;
						PutCircle(4);
						I:=3;
						MouseOn;
					End;
				If (L=True) And (MouseX>=227) And (MouseX<=235) And (MouseY>=107) And (MouseY<=115) And (I<>4) Then
					Begin
						MouseOff;
						PutCircle(5);
						I:=4;
						MouseOn;
					End;
			Until AcceptControl=True;
			If AcceptControl Then InitColors(I);
			SetFillStyle(0,0);
			Bar(140,25,250,150);
		End;

	Procedure ReadButton;
		Var C:Char;
		Begin
			C:=ReadKey;
			If (Ord(c)=27) Or (Ord(c)=68) Or (Ord(c)=26) Or (Ord(c)=3)
			Or (Ord(c)=103) Or (Ord(c)=16) Or (Ord(c)=17) Or (Ord(c)=24)
			Or (Ord(c)=44) Or (Ord(c)=45)	Or (UpCase(c)='Q') Or (UpCase(c)='X') Then Stop;
			If (Ord(c)=59) Or (Ord(c)=35) Then Help;
			If (UpCase(c)='N') Or (UpCase(c)='R') Or (UpCase(c)='S') Then RestartControl:=True;
			If (UpCase(c)='C') Then SelectColors;
			{New,Restart,Stop}
		End;
	Procedure DrawPlace(Place:Integer);
		Begin
			SetColor(Colors.MonoRed);
			SetFillStyle(10,Colors.MonoGreen);
			MouseOff;
				If Place=1 Then Bar3D(240,190,290,240,0,TopOn);
				If Place=2 Then Bar3D(290,190,340,240,0,TopOn);
				If Place=3 Then Bar3D(340,190,390,240,0,TopOn);
				If Place=4 Then Bar3D(240,240,290,290,0,TopOn);
				If Place=5 Then Bar3D(290,240,340,290,0,TopOn);
				If Place=6 Then Bar3D(340,240,390,290,0,TopOn);
				If Place=7 Then Bar3D(240,290,290,340,0,TopOn);
				If Place=8 Then Bar3D(290,290,340,340,0,TopOn);
				If Place=9 Then Bar3D(340,290,390,340,0,TopOn);
			MouseOn;
			SetColor(Colors.MonoGreen);
		End;
	Function InputPlace(Var RestartControl:Boolean):Integer;
		Var MouseX,MouseY,Posit:Integer;
			L,R:Boolean;
	Begin
		MouseOn;
		L:=False;
		Repeat
			MouseInfo(MouseX,MouseY,L,R);
				If (KeyPressed) Then ReadButton;
				If RestartControl Then Break;{⭮  !Only for Buttons!}
				If ((L=True) And (MouseX>=566) And (MouseX<=613) And (MouseY>=6) And (MouseY<=19)) Then Help;
		Until ((L=True) And (MouseX<=388) And (MouseX>=242) And (MouseY>=192) And (MouseY<=338))
				Or
				((L=True) And (MouseX>=26) And (MouseX<=75) And (MouseY>=6) And (MouseY<=19))
				Or
				((L=True) And (MouseX>=86) And (MouseX<=133) And (MouseY>=6) And (MouseY<=19));
		L:=False;
		Posit:=0;
			If (MouseX>=242) And (MouseX<=288) And (MouseY>=192) And (MouseY<=238) Then Posit:=1;
			If (MouseX>=292) And (MouseX<=338) And (MouseY>=192) And (MouseY<=238) Then Posit:=2;
			If (MouseX>=342) And (MouseX<=388) And (MouseY>=192) And (MouseY<=238) Then Posit:=3;
			If (MouseX>=242) And (MouseX<=288) And (MouseY>=242) And (MouseY<=288) Then Posit:=4;
			If (MouseX>=292) And (MouseX<=338) And (MouseY>=242) And (MouseY<=288) Then Posit:=5;
			If (MouseX>=342) And (MouseX<=388) And (MouseY>=242) And (MouseY<=288) Then Posit:=6;
			If (MouseX>=242) And (MouseX<=288) And (MouseY>=292) And (MouseY<=338) Then Posit:=7;
			If (MouseX>=292) And (MouseX<=338) And (MouseY>=292) And (MouseY<=338) Then Posit:=8;
			If (MouseX>=342) And (MouseX<=388) And (MouseY>=292) And (MouseY<=338) Then Posit:=9;
				If (MouseX>=26) And (MouseX<=75) And (MouseY>=3) And (MouseY<=22) Then
					Begin
						Posit:=0;
						Stop;
					End;
				If (MouseX>=85) And (MouseX<=133) And (MouseY>=3) And (MouseY<=22) Then RestartControl:=True;
		InputPlace:=Posit;
	End;
	Procedure DrawDigit(Place,Digit,Comp:Integer);
		Var StD:String;
		Begin
			SetTextStyle(DefaultFont,0,0);
			SetColor(Colors.MonoRed);
			MouseOff;
				If Digit=1 Then OutTextXY(250,400,'1');
				If Digit=2 Then OutTextXY(266,400,'2');
				If Digit=3 Then OutTextXY(282,400,'3');
				If Digit=4 Then OutTextXY(298,400,'4');
				If Digit=5 Then OutTextXY(314,400,'5');
				If Digit=6 Then OutTextXY(330,400,'6');
				If Digit=7 Then OutTextXY(346,400,'7');
				If Digit=8 Then OutTextXY(362,400,'8');
				If Digit=9 Then OutTextXY(378,400,'9');
			Str(Digit,StD);
			SetFillStyle(10,Colors.MonoGreen);
				If Place=1 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(240,190,290,240,0,TopOn);
						SetColor(Comp);
						OutTextXY(261,211,StD);
					End;
				If Place=2 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(290,190,340,240,0,TopOn);
						SetColor(Comp);
						OutTextXY(311,211,StD);
					End;
				If Place=3 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(340,190,390,240,0,TopOn);
						SetColor(Comp);
						OutTextXY(361,211,StD);
					End;
				If Place=4 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(240,240,290,290,0,TopOn);
						SetColor(Comp);
						OutTextXY(261,261,StD);
					End;
				If Place=5 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(290,240,340,290,0,TopOn);
						SetColor(Comp);
						OutTextXY(311,261,StD);
					End;
				If Place=6 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(340,240,390,290,0,TopOn);
						SetColor(Comp);
						OutTextXY(361,261,StD);
					End;
				If Place=7 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(240,290,290,340,0,TopOn);
						SetColor(Comp);
						OutTextXY(261,311,StD);
					End;
				If Place=8 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(290,290,340,340,0,TopOn);
						SetColor(Comp);
						OutTextXY(311,311,StD);
					End;
				If Place=9 Then
					Begin
						SetColor(Colors.MonoGreen);
						Bar3D(340,290,390,340,0,TopOn);
						SetColor(Comp);
						OutTextXY(361,311,StD);
					End;
		End;
	Function InputDigit(Var RestartControl:Boolean):Integer;
		Var PositDigit,MouseX,MouseY:Integer;
			 L,R:Boolean;
		Begin
			L:=False;
			Repeat
			MouseInfo(MouseX,MouseY,L,R);
				If (KeyPressed) Then ReadButton;
				If RestartControl Then Break;
				If ((L=True) And (MouseX>=566) And (MouseX<=613) And (MouseY>=6) And (MouseY<=19)) Then Help;
			Until ((L=True) And (MouseX>=242) And (MouseX<=382) And (MouseY>=396) And (MouseY<=405))
					Or
					((L=True) And (MouseX>=26) And (MouseX<=75) And (MouseY>=6) And (MouseY<=19))
					Or
					((L=True) And (MouseX>=86) And (MouseX<=133) And (MouseY>=6) And (MouseY<=19));
			L:=False;
			PositDigit:=0;
				If (MouseX>=246) And (MouseX<=258) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=1;
				If (MouseX>=259) And (MouseX<=274) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=2;
				If (MouseX>=275) And (MouseX<=290) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=3;
				If (MouseX>=291) And (MouseX<=306) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=4;
				If (MouseX>=307) And (MouseX<=322) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=5;
				If (MouseX>=323) And (MouseX<=338) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=6;
				If (MouseX>=339) And (MouseX<=354) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=7;
				If (MouseX>=355) And (MouseX<=370) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=8;
				If (MouseX>=371) And (MouseX<=382) And (MouseY>=398) And (MouseY<=405) Then PositDigit:=9;
				If (MouseX>=26) And (MouseX<=75) And (MouseY>=3) And (MouseY<=22) Then Stop;
				If (MouseX>=85) And (MouseX<=133) And (MouseY>=3) And (MouseY<=22) Then RestartControl:=True;
			InputDigit:=PositDigit;
		End;
	Procedure PlayComputer(Var Place,Digit:Integer);
		Begin
			Digit:=Random(10);
			Place:=Random(10);
			If (Place=10) Then Place:=Place - 1;
			If (Digit=10) Then Digit:=Digit - 1;
		End;
	Procedure RegisterBGIFile(BGIName:String);
		Var BGIFile:File;
			P:Pointer;
		Begin
			Assign(BGIFile,BGIName);
			Reset(BGIFile,1);
			GetMem(P,FileSize(BGIFile));
			BlockRead(BGIFile,P^,FIleSize(BGIFile));
			Close(BGIFile);
				If (Copy(BGIName,Length(BGIName)-3,Length(BGIName))='Bgi') Then
				If RegisterBGIDriver(P)<0 Then StandartErrors(-1,-1)
				Else
				If RegisterBGIFont(P)<0 Then StandartErrors(0,0);
				If GraphResult<0 Then StandartErrors(-1,-1);
		End;
	Procedure Draw;
		Var I,Step:Integer;
		Begin
			MouseOff;
			ClearDevice;
			SetTextJustify(LeftText,TopText);
			SetFillStyle(0,0);
			SetColor(Colors.MonoBrown);
			RecTangle(0,0,639,479);
			SetColor(Colors.MonoBlue);
			SetFillStyle(10,Colors.MonoBlue);
			Bar(206,140,456,370);
			SetColor(Colors.MonoGreen);
			SetFillStyle(10,Colors.MonoGreen);
			Bar3D(240,190,390,340,33,TopOn);
			SetFillStyle(11,Colors.MonoGreen);
			FloodFill(391,193,Colors.MonoGreen);
			Comp:=GraphResult;
				If Comp<0 Then StandartErrors(Comp,Comp);
			FloodFill(245,189,Colors.MonoGreen);
			Comp:=GraphResult;
				If Comp<0 Then StandartErrors(Comp,Comp);
			Line(290,190,290,340);
			Line(340,190,340,340);
			Line(240,240,390,240);
			Line(240,290,390,290);
			Line(290,190,326,166);
			Line(340,190,376,166);
			Line(390,240,422,215);
			Line(390,290,422,265);
			SetFillStyle(1,Colors.MonoLightGray);
			Step:=24;
				For I:=1 to 10
					Do
						Begin
							Bar(Step,5,Step+50,20);
							Step:=Step+60;
						End;
			SetColor(Colors.MonoLightRed);
			OutTextXY(33,10,'Exit');
			OutTextXY(97,10,'New');
			OutTextXY(146,10,'Colors');
			OutTextXY(573,10,'Help');
			SetColor(Colors.MonoGreen);
			OutTextXY(250,400,'1 2 3 4 5 6 7 8 9');
			OutTextXY(92,212,'Mode : ');
			OutTextXY(84,244,'Action : ');
			SetColor(Colors.MonoRed);
			OutTextXY(363,465,'Artiom Nechiporuck produced');
			OutTextXY(584,465,'c');
			OutTextXY(595,465,'2003');
			Circle(587,469,5);
			SetTextStyle(7,0,1);
			SetUserCharSize(1,2,3,7);
			OutTextXY(5,10,'V');
			OutTextXY(5,TextHeight('V')*2 - 4,'o');
			OutTextXY(5,TextHeight('l')*3 - 4,'l');
			OutTextXY(5,TextHeight('t')*4 - 4,'t');
			SetColor(Colors.MonoWhite);
			SetTextStyle(4,0,5);
			Comp:=GraphResult;
				If Comp<0 Then StandartErrors(Comp,-1);
			OutTextXY(175,50,'Matchematics game');{198,50,defaultfont}
			SetTextStyle(DefaultFont,0,2);
			MouseOn;
		End;
		Procedure WorkWithFile;
			Type GamesInfo = Array[1..5] Of Record
														  PlayerName:String;
														  Num1,Num2:Integer;
													  End;
			Label ResetError,StopWriting;
			Var OneGame:GamesInfo;
				ResultsFile:File Of GamesInfo;
				N,I,Scan:Integer;
				NStr:String;
				C:Char;
				Procedure ReadName(Var PlayerName:String);
					Var PosC:Integer;
					Begin
						PlayerName[0]:=#25;
						For PosC:=1 To 25
							Do
								PlayerName[PosC]:=' ';
						PosC:=1;
						Repeat
						C:=ReadKey;
							If (Ord(C)=8) And (GetX>82) Then
								Begin
									Delete(PlayerName,PosC - 1,1);
									PosC:=PosC - 1;
									MoveTo(GetX - 8,GetY);
									Bar(GetX,GetY - 6,GetX + 8,GetY + 8);
								End;
							If (PosC<=25) And (Ord(c)>23) And (Ord(c)<126) Then
								Begin
									OutText(C);
									PlayerName[PosC]:=C;
									PosC:=PosC + 1;
								End;
						Until (PosC=25) Or (Ord(c)=13);
					End;
			Begin
				SetTextStyle(DefaultFont,0,0);
				SetColor(Colors.MonoGreen);
				ClearViewPort;
				OutTextXY(50,2,'Name of player : ');
				OutTextXY(250,2,'Player''s 1 points : ');
				OutTextXY(450,2,'Other points : ');
				SetColor(Colors.MonoRed);
				Assign(ResultsFile,'MathGame.Rez');
				SetFillStyle(0,0);
				Reset(ResultsFile);
				N:=0;
				If (IOResult<>0) Then
					Begin
						ResetError :
						ReWrite(ResultsFile);
							If (IOResult<>0) Then StandartErrors(1,1);
						I:=16;
						For N:=2 To 5
							Do
								Begin
									With OneGame[N]
										Do
											Begin
												Num1:=0;
												Num2:=0;
												PlayerName:=' -                         ';
												SetTextStyle(0,0,0);
												I:=I+16;
												Str(N,NStr);
												OutTextXY(50,I,NStr+'. ');
												OutTextXY(74,I,PlayerName);
												Str(Num1,NStr);
												OutTextXY(300,I,NStr);
												Str(Num2,NStr);
												OutTextXY(450,I,NStr);
											End;
						End;
									With OneGame[1]
										Do
											Begin
												If ((Player1Num - Numb2)>0) And COrP Then
													Begin
														Num1:=Player1Num;
														Num2:=Numb2;
													End
													Else
														Begin
															Num1:=0;
															Num2:=0;
															PlayerName:=' -                         ';
														End;
												SetTextStyle(0,0,0);
												OutTextXY(50,16,'1. ');
												Str(Num1,NStr);
												OutTextXY(300,16,NStr);
												Str(Num2,NStr);
												OutTextXY(450,16,NStr);
												MoveTo(82,16);
												If ((Player1Num - Numb2)>0) And COrP Then
												Begin
													SetColor(Colors.MonoWhite);
													OutTextXY(74,16,'');
													SetColor(Colors.MonoRed);
													ReadName(PlayerName);
												End
												Else OutTextXY(74,16,PlayerName);
											End;
						Scan:=1;
						Write(ResultsFile,OneGame);
						Truncate(ResultsFile);
						Close(ResultsFile);
					End
				Else
					Begin
						Scan:=Player1Num - Numb2;
						Read(ResultsFile,OneGame);
						Close(ResultsFile);
						I:=0;
						For N:=1 To 5
							Do
								Begin
									I:=I+16;
									With OneGame[N]
										Do
											Begin
												SetTextStyle(0,0,0);
												Str(Num1,NStr);
												OutTextXY(300,I,NStr);
												Str(Num2,NStr);
												OutTextXY(450,I,NStr);
												Str(N,NStr);
												OutTextXY(50,I,NStr + '. ' + PlayerName);
											End;
								End;
						For N:=1 To 5
							Do
								Begin
									I:=I+16;
									With OneGame[N]
										Do
											Begin
													If ((Player1Num - Numb2) > (Num1 - Num2)) And COrP Then
														Begin
															Num1:=Player1Num;
															Num2:=Numb2;
															Bar(74,16*N,500,(N*16) + 15);
															SetColor(Colors.MonoWhite);
															OutTextXY(74,N*16,'');
															SetColor(Colors.MonoRed);
															MoveTo(82,16*N);
															Str(Num1,NStr);
															OutTextXY(300,N*16,NStr);
															Str(Num2,NStr);
															OutTextXY(450,N*16,NStr);
															ReadName(PlayerName);
															ReWrite(ResultsFile);
															Write(ResultsFile,OneGame);
															Close(ResultsFile);
															Goto StopWriting;
														End;
											End;
								End;

					End;
			StopWriting :
		End;
{  ,᭮ !}
Begin
	TextColor(Black);
	TextBackGround(Blue);
	ClrScr;
	Write(' Loading,please wait...');
	Randomize;
	Messages[1,1]:='Player2 is a winner!';
	Messages[2,1]:='It is a crash of Player1!';
	Messages[3,1]:='Player2 won in this game!';
	Messages[4,1]:='Player1 won!';
	Messages[5,1]:='Don''t forget,that Player1 is a man of genius in this game!';
	Messages[6,1]:='Player1 is a king of this game!';
	Messages[1,2]:='Sorry,but Computer killed you!';
	Messages[2,2]:='Ooo..oh!I''m won!';
	Messages[3,2]:='But you are lost...';
	Messages[4,2]:='Player1 get the prize!';
	Messages[5,2]:='You are won!!!';
	Messages[6,2]:='FUCK!!!I''m looser.No comment!';
	Assign(HlpFile,'MathGame.Hlp');
	Reset(HlpFile);
	If (IOResult<>0) Then StandartErrors(6,-1);
	Read(HlpFile,HelpText);
	If (IOResult<>0) Then StandartErrors(6,-1);
	Close(HlpFile);
	If (HelpText.Docs[1]<>'MATCHEMATICS GAME HELP FILE.') Then StandartErrors(6,-1);
	Comp:=0;
		If (InitMouse=False) Or (MouseDriverPresent=False) Then StandartErrors(Comp,1);

	RegisterBGIFile('EgaVga.Bgi');

	RegisterBGIFile('Goth.Chr');

	RegisterBGIFile('Tscr.Chr');
	TextColor(LightGray);
	TextBackGround(Black);
	Write('.');
	ClrScr;
	DetectGraph(GrDriver,GrMode);
	InitGraph(GrDriver,GrMode,'');
	Comp:=GraphResult;
		If Comp<>0 Then StandartErrors(Comp,-1);
	InitColors(0);
	SetBkColor(Colors.MonoBlack);
	GetMem(p,ImageSize(170,165,470,255));
	Restart :
	ClearDevice;
	Place:=0;
	GrDriver:=0;
	GrDriver:=GrMode;
	RestartControl:=False;
	COrP:=False;
	FirstMove:=False;
	For Number:=1 To 9
		Do
			Matrix[Number]:=0;
	CheckBreak:=False;
	MouseOn;
	SetMousePos(1,1);
	DrawMenus('Computer','Second gamer','You want to play with : ',COrP);
	MouseInfo(Player1Num,Numb2,L,L);
		If (Player1Num>=187) And (Player1Num<=313) And (Numb2>=212) And (Numb2<=238)
	Then SetMousePos(Player1Num,211);
		If (COrP=True) Then DrawMenus('Computer','You','Who will do the first move :',FirstMove);
	MouseInfo(Player1Num,Numb2,L,L);
	SetMousePos(Player1Num,190);
	Draw;
	SetColor(Colors.MonoRed);
	SetTextStyle(DefaultFont,0,0);
	MouseOff;
	OutTextXY(60,260,'Enter the place');
	GrMode:=0;
		If (COrP=True) Then GrMode:=1;
			SetColor(Colors.MonoRed);
		If (GrMode=0) Then
			Begin
				OutTextXY(71,228,'Two players');
				SetColor(Colors.MonoGreen);
				OutTextXY(40,276,'This move will do : ');
				SetColor(Colors.MonoRed);
				OutTextXY(88,292,'Player 1');
			End;
		If (GrMode=1) Then OutTextXY(44,228,'Computer and player');
	Comp:=Colors.MonoYellow;
	Start :
	GrDriver:=0;
	For Number:=1 To 9
			Do
				If (Matrix[Number]=0) Then GrDriver:=GrDriver + 1;
		If (COrP=True) And (FirstMove=True) Then
			Begin
				Comp:=Colors.MonoYellow;
				PlayComputer(Place,Digit);
				If (Matrix[Place]<>0) Then Goto Start;
					For Number:=1 To 9
						Do
							If (Matrix[Number]=Digit) Then Goto Start;
				DrawDigit(Place,Digit,Comp);
				Matrix[Place]:=Digit;
				GrDriver:=GrDriver - 1;
			End;
	If Comp=Colors.MonoBlue Then Comp:=Colors.MonoYellow
	Else Comp:=Colors.MonoBlue;
	SetColor(Colors.MonoBlack);
	SetFillStyle(0,0);
	SetColor(Colors.MonoRed);
	Bar(145,292,155,300);
	If (Comp=Colors.MonoYellow) And (COrp=False) Then OutTextXY(145,292,'2');
	If (Comp=Colors.MonoBlue) And (COrP=False) Then OutTextXY(145,292,'1');
	Bar(140,260,180,270);
	If (GrDriver<=0) Then Goto TheEnd;
	OutTextXY(140,260,'place');
	MouseOn;
	StartPlace :
	Place:=InputPlace(RestartControl);
		If (RestartControl) Then
			Begin
				MouseOff;
				GetImage(170,165,470,255,p^);
				MouseOn;
				DrawMenus('Yes','No','Are you sure ? ',RestartControl);
				If (RestartControl=True) Then Goto Restart;
				MouseOff;
				PutImage(170,165,p^,NormalPut);
				MouseOn;
			End;
	RestartControl:=False;
		If (Place<=0) Or (Matrix[Place]>0) Then
			Begin
				FirstMove:=False;
				Goto StartPlace;
			End;
	Sound(900);
	Delay(700);
	NoSound;
	DrawPlace(Place);
	SetColor(Colors.MonoBlack);
	SetFillStyle(0,0);
	Bar(140,260,180,270);
	SetColor(Colors.MonoRed);
	MouseOff;
	OutTextXY(140,260,'digit');
	MouseOn;
	IDigit :
	Digit:=InputDigit(RestartControl);;
		If (RestartControl) Then
			Begin
				MouseOff;
				GetImage(170,165,470,255,p^);
				MouseOn;
				DrawMenus('Yes','No','Are you sure ? ',RestartControl);
				If (RestartControl=True) Then Goto Restart;
				MouseOff;
				PutImage(170,165,p^,NormalPut);
				MouseOn;
			End;
	RestartControl:=False;
	For Number:=1 To 9
		Do
			If (Matrix[Number]=Digit) Then Goto IDigit;
	Sound(900);
	Delay(700);
	NoSound;
	DrawDigit(Place,Digit,Comp);
	Matrix[Place]:=Digit;
	FirstMove:=True;
	GrDriver:=GrDriver - 1;
	If (GrDriver>0) Then Goto Start;
	TheEnd :
	Player1Num:=(Matrix[1]*Matrix[2]*Matrix[3]+Matrix[4]*Matrix[5]*Matrix[6]+Matrix[7]*Matrix[8]*Matrix[9]);
	Numb2:=(Matrix[1]*Matrix[4]*Matrix[7]+Matrix[2]*Matrix[5]*Matrix[8]+Matrix[3]*Matrix[6]*Matrix[9]);
	Number:=Player1Num - Numb2;
	SetBkColor(Colors.MonoCyan);
		If COrP=True Then
			Begin
					If Number<0 Then
						Begin
							ClearViewPort;
							SetColor(Colors.MonoRed);
							SetTextStyle(Random(3)+6,0,2);
							OutTextXY(150,200,Messages[Random(3),2]);
						End;
					If Number>0 Then
						Begin
							ClearViewPort;
							SetColor(Colors.MonoRed);
							SetTextStyle(Random(3)+6,0,2);
							OutTextXY(150,200,Messages[Random(3)+3,2]);
						End;
			End;
		If COrP=False Then
			Begin
					If Number<0 Then
						Begin
							ClearViewPort;
							SetColor(Colors.MonoRed);
							SetTextStyle(Random(3)+6,0,2);
							OuTtextXY(50,100,Messages[Random(3),1]);
						End;
					If Number>0 Then
						Begin
							ClearViewPort;
							SetColor(Colors.MonoRed);
							SetTextStyle(Random(3)+6,0,2);
							OutTextXY(50,100,Messages[Random(3)+3,1]);
						End;
			End;
	Repeat
	Until KeyPressed;
	C:=ReadKey;
	SetBkColor(Colors.MonoBlack);
	WorkWithFile;
	SetMousePos(1,1);
	DrawMenus('Yes','No','Play again ?',RestartControl);
	If RestartControl Then Goto Restart
	Else ExitGame;
End.
(*ணࠬ ᮧ ⥬ 稯  2003   몥 Turbo Pascal 7.0.
   ᯮ짮 ⠭ 㫨 Pascal   Mouse.tpu,⢥騩
  ࠡ  .
 ࠢ ணࠬ   ,  ᯮ짮 ⮫쪮
  맮   ࠡ  .
 ணࠬ ࠡ⠥  MS-DOS 6.22   ( MS-DOS ,祬 6.22 
 뢠)   ஬ 80286   ( ४⨢ {$G+},
  㢥稢 ᪮ ࠡ).
   ࠡ⠥  VGA/CGA  (楤 DetectGraph ᯮ
 ࠩ EgaVga.Bgi), IBM8514 㤥 㫨஢ VGA.*)
